$(function () {
    // log('');
    // 该值为localstorage中的key, 存储最新的规则库版本号
    var LATEST_BASE_RULE_VERSION = 'LAST_MAGNUM_BASE_RULE_VERSION';
    //Web版本号存储在 localstorage中
    localStorage.WebAppVersion = localStorage.WebAppVersion || '0.0.0';
    localStorage[LATEST_BASE_RULE_VERSION] = localStorage[LATEST_BASE_RULE_VERSION] || '0.0.0';
    document.addEventListener('deviceready', function () {
       
        try {
            generateBackgroundImg();
        } catch (error) {
            console.log("-------------"+error)
            $('body').css('background', 'url("imgs/start_0.jpg") no-repeat');
            $('body').css('background-size', 'cover');
        }

        //本地存储的更新包的版本
        var localPackage = {
            filePath: cordova.file.applicationDirectory + 'www/www.zip',
            version: '0.0.0'
        };

        var localMagnum = {
            filePath: cordova.file.applicationDirectory + 'www/ruleBase.zip',
            version: '0.0.0'
        }

        var params = getParams();
        // 目前有两个值
        // init: 此时只需要解压本地的前端资源包和magnum包
        // update: 该操作时 需要去服务器检查更新
        var operator = params.operator;

        var env = (params.env || 'PRO').toUpperCase();
        //服务器地址
        var SERVERPATH = 'https://osp.newchinalife.com/';// 生产环境
        if (env === 'DEV') {
            SERVERPATH = 'http://192.168.43.197:3000/';// 开发环境
        } else if (env === 'SIT') {
            SERVERPATH = 'http://osptest.newchinalife.com/sit/';// SIT环境
        } else if (env === 'UAT') {
            SERVERPATH = 'http://osptest.newchinalife.com/uat/';// UAT环境
        } else if (env === 'PRE') {
            SERVERPATH = 'http://osptest.newchinalife.com/pre/';// UAT环境
        }

        //当前APP版本
        var appVersion = '1.0.0';

        //解压路径
        var HTMLPATH = cordova.file.dataDirectory + 'www/';
        var MAGNUMPATH = cordova.file.dataDirectory + 'magnum/';
        var PLATFORM = 'iOS'
        //如果是安卓 则修改标识
        if (navigator.userAgent.indexOf('SINO_ANDROID_APP') != -1) PLATFORM = 'Android';

        if (operator === 'init') {
            initPackage();
        } else {
            checkUpdate();
        }

        /**
         * 初始化版本信息
         */
        function initPackage() {
            var updateLists = [];
            // 如果当前版本为0.0.0 或者当前APP自带版本大于本地包则先解压 因为app中都带有了最新的前端包 不必要再更新一次
            if (localStorage.WebAppVersion === '0.0.0' || version2Num(localStorage.WebAppVersion) < version2Num(localPackage.version)) {
                updateLists.push({ filePath: localPackage.filePath, toVersion: localPackage.version, packageType: 'FULL', type: 'WEB', typeName: '内容包' })
            }

            // 如果当前magnum版本为0.0.0 或者当前自带版本大于本地包则先解压
            if (localStorage[LATEST_BASE_RULE_VERSION] === '0.0.0' || version2Num(localStorage[LATEST_BASE_RULE_VERSION]) < version2Num(localMagnum.version)) {
                updateLists.push({ filePath: localMagnum.filePath, toVersion: localMagnum.version, type: 'MAGNUM', typeName: '规则库' });
            }

            if (updateLists.length > 0) {
                unzips(updateLists, function (result) {
                    afterUpdate(result);
                })
            } else {
                afterUpdate({ flag: 1 })
            }
        }

        /**
         * 启动页图片显示规则
         * 1.卸载重安时显示引导图片 (此图片存在cordova中)
         * 2.后台管理系统未配置图片时 显示默认图片(此图片在前端项目中)
         * 3.后台管理系统有配置时 显示配置的图片 
         * 
         */
        function generateBackgroundImg() {

            // 启动页图片目录
            let dir= cordova.file.dataDirectory+'startupPagePictureDirectory'; 
            // 前端项目资源文件
            let fileUrl = cordova.file.dataDirectory + 'www/static/images/advertising/start_0.jpg';

            sino_file.isExist(fileUrl, function (result) {
                if (result.isExist === 1) {
                            sino_file.listFiles(
                            dir,
                            (result) =>{
                                let imgUrl
                                if(result.length==1){ //展示配置的图片
                                    imgUrl = dir+'/'+result[0].name
                                    getimgRequst(result[0].name,dir)
                                }else{ 
                                    imgUrl = fileUrl;
                                    getimgRequst('',dir)
                                }
                                $('body').css('background', 'url("' + imgUrl + '") no-repeat');
                                $('body').css('background-size', 'cover');
                            },
                            ()=>{
                                //启动页图片文件夹不存在时
                                $('body').css('background', 'url("' + fileUrl + '") no-repeat');
                                $('body').css('background-size', 'cover');
                                getimgRequst('',dir)
                            })
                } else {
                    $('body').css('background', 'url("imgs/start_0.jpg") no-repeat');
                    $('body').css('background-size', 'cover');
                    getimgRequst('',dir)
                }

            })
            
        }
        /**
         * 请求启动页配置的图片
         * 将后台管理系统配置的图片存入startupPagePictureDirectory文件夹下
         */
        function getimgRequst(existsImg,dir){
            $.ajax({
                url: SERVERPATH +'opensale/qms/qms/topic/getStart/nologin',
                type: 'get',
                xhrFields: {
                    withCredentials: true
                },                
                dataType: 'json',
                success: function (data) {
                    let imageName = data.data.imageName || '';
                    let imagePath = data.data.imagePath
                    if( existsImg && (imagePath=='' || existsImg!=imageName )){
                        sino_file.delete(dir,
                        (en)=>{
                            console.log("删除启动页图片文件夹")
                        })
                    }
                    
                    if(imageName!=='-' && imageName!=existsImg){
                        sino_file.download(imagePath,dir+'/'+imageName,
                        (entry)=>{
                                console.log("启动页-下载图片成功")
                        })
                    }
                },
            })
        }

        function randomNum (min, max) {
            return Math.floor(Math.random() * (max - min + 1)) + min;
        }
        // 已经使用了的url
        var alreadyUseUrls = {
            web: [], // 已经使用了的web下载地址
            lastWeb: '', // 上一次使用的web下载地址 用来再次请求时添加到已使用数组中
            magnum: [], // 已经使用了的magnum下载地址
            lastMagnum: '' // 上一次使用的magnum下载地址 用来再次请求时添加到已使用数组中
        };
        function checkUpdate() {
            // 获得当前版本的版本号信息
            cordova.getAppVersion.getVersionCode(function (verCode) {
                verCode = num2Version(verCode);
                console.log('url:', SERVERPATH + 'opensale/ams/app/update/check')
                $.ajax({
                    url: SERVERPATH + 'opensale/ams/app/update/check',
                    type: 'post',
                    data: JSON.stringify({
                        appVersion: verCode,
                        webVersion: localStorage.WebAppVersion,
                        magnumVersion: localStorage[LATEST_BASE_RULE_VERSION],
                        platform: PLATFORM.toLowerCase()
                    }),
                    processData: false,
                    contentType: 'application/json;charset=UTF-8',
                    xhrFields: {
                        withCredentials: true
                    },
                    dataType: 'json',
                    success: function (data) {
                        
                        // 检查更新成功
                        if (data.flag == 1) {
                            // 如果APP 有更新则检查APP更新 并且不再检查其他资源的更新
                            if (data.app && data.app.length > 0) {
                                // 选择第0个进行下载 后台会根据
                                var app = data.app[randomNum(0, data.app.length - 1)];
                                navigator.notification.alert('APP版本已更新，请点击确定下载', function (btn) {
                                    cordova.InAppBrowser.open(app.downloadURL, '_system');
                                }, '提示', '确定');
                                return;
                            }

                            var updateLists = [];
                            // 前端页面有更新
                            var haveUpdate = false; // 是否有更新标识
                            var isWebError = false;
                            if (data.web && data.web.channel && data.web.channel.length > 0 && data.web.updates && data.web.updates.length > 0) {
                                haveUpdate = true;

                                // 如果有web更新 并且上一次选择的下载渠道中有值 则说明上一次更新web时出错了 需要将该渠道忽略
                                if (alreadyUseUrls.lastWeb) {
                                    alreadyUseUrls.web.push(alreadyUseUrls.lastWeb);
                                    alreadyUseUrls.lastWeb = '';
                                    // 进入此处说明是web更新出错了 
                                    isWebError = true;
                                } 

                                // 过滤掉已经尝试过的渠道
                                var channels = data.web.channel.filter(function (channel) {
                                    return alreadyUseUrls.web.indexOf(channel.key) == -1;
                                });
                                
                                if (channels.length > 0) {
                                    // 如果还有未尝试过的下载渠道 随机选择一个下载渠道
                                    var channel = alreadyUseUrls.lastWeb = channels[randomNum(0, channels.length - 1)].key;
                                    log('当前使用的[前端资源包]下载渠道为:' + channel);
                                    var updates = data.web.updates;
                                    for (var i = 0; i < updates.length; i++) {
                                        var info = updates[i];
                                        updateLists.push({
                                            downUrl: info[channel] + '?v=' + new Date().getTime(),
                                            toVersion: info.toVersion,
                                            sha1: info.sha1,
                                            packageType: info.type, // 更新包类型 FULL: 全量包 PATCH: 增量包
                                            type: 'WEB',
                                            typeName: '前端页面包'
                                        })
                                    }
                                } else {
                                    // 如果此时下载渠道列表为空 说明所有渠道均已尝试 均下载失败直接回调不再继续执行
                                    afterUpdate({ flag: -1});
                                    return;
                                }
                            }

                            if (data.magnum && data.magnum.length > 0) {
                                
                                // 如果有magnum更新 且 不是web更新出错 且 lastMagnum不为空 说明上一次为更新magnum时出错
                                // 需要将上次使用的下载渠道忽略掉 
                                if (!isWebError && alreadyUseUrls.lastMagnum !== '') {
                                    alreadyUseUrls.magnum.push(alreadyUseUrls.lastMagnum);
                                    alreadyUseUrls.lastMagnum = '';
                                }
                                // 校验完后再设置该值
                                haveUpdate = true;
                                // 过滤掉已经使用了的下载渠道
                                var magnums = data.magnum.filter(function (item) {
                                    return alreadyUseUrls.magnum.indexOf(item.name) == -1;
                                });
                                // 如果还有未尝试过的下载地址
                                if (magnums.length > 0) {
                                    // 随机获取一个
                                    var key = randomNum(0, magnums.length - 1)
                                    alreadyUseUrls.lastMagnum = magnums[key].name;
                                    log('当前使用的[Mangnum]下载渠道为:' + alreadyUseUrls.lastMagnum);
                                    updateLists.push({
                                        downUrl: magnums[key].downloadURL + '?v=' + new Date().getTime(),
                                        toVersion: magnums[0].toVersion,
                                        sha1: magnums[0].sha1,
                                        type: 'MAGNUM',
                                        typeName: '规则库'
                                    })
                                }
                            }
                            // updateLists长度大于0说明有更新 开始更新
                            if (updateLists.length > 0) {
                                downAndUnZip(updateLists, afterUpdate);
                            } else if (haveUpdate && updateLists.length == 0) {
                                // 如果有更新但是却updateLists却为空 说明所有的更新渠道均已尝试无法下载
                                afterUpdate({ flag: -1});

                            }else { // 没有更新
                                afterUpdate({ flag: 2 });
                            }
                        } else {
                            log('没有检查到更新');
                            afterUpdate({ flag: 2 });
                        }
                    },
                    error: function () {
                        $('#outtips').show();
                        log('连接服务器失败');
                        afterUpdate({ flag: 0 });
                    }
                });
            })
        }

        function completeURL(url) {
            //如果返回的路径不是http 和 https开头 则拼接服务器地址
            if (url.indexOf('http://') !== 0 && url.indexOf('https://') !== 0) {
                url = SERVERPATH + url;
            }

            return url;
        }

        function afterUpdate(data) {
            console.log('')
            if (data.flag === 1) {
                // log('更新成功,当前版本号为:' + localStorage.WebAppVersion);
                log('更新完成');
                setTimeout(function () {
                    toHome();
                }, 2500)
            } else if (data.flag === 2) {
                setTimeout(function () {
                    toHome();
                }, 2500)
            } else {
                log(data.cause || '更新失败,当前版本号为:' + localStorage.WebAppVersion);
                // 如果是-1 说明所有渠道都尝试了 全部失败
                navigator.notification.confirm('更新失败,是否重试?', function (btn) {
                    // -1 说明所有的下载渠道均已尝试并且全部下载失败 此时重试需要清空已尝试的下载渠道数据
                    if (data.flag == -1) {
                        alreadyUseUrls = {
                            web: [], // 已经使用了的web下载地址
                            lastWeb: '', // 上一次使用的web下载地址 用来再次请求时添加到已使用数组中
                            magnum: [], // 已经使用了的magnum下载地址
                            lastMagnum: '' // 上一次使用的magnum下载地址 用来再次请求时添加到已使用数组中
                        };
                    }
                    //不是取消则重试
                    if (btn !== 2) {
                        if (operator === 'init') {
                            initPackage();
                        } else {
                            checkUpdate();
                        }
                    }
                }, '提示')


            }
        }

        function toHome() {
            // log('更新完成');
            location.href = cordova.file.dataDirectory + 'www/index.html?v=' + new Date().getTime();
            //location.href = 'http://192.168.43.197:3000'
        }

        /**
         * 下载更新包 并解压 完成后调用回调函数
         * @param  {[type]}   datas     [description]
         * @param  {Function} callback [description]
         * @return {[type]}            [description]
         */
        function downAndUnZip(datas, callback, index) {
            if (!index) index = 0;
            var url = completeURL(datas[index].downUrl);

            var fileTransfer = new FileTransfer();

            function onDownloadSuccess(entry) {
                log('下载' + datas[index].typeName + '更新包成功');
                // 下载成功后校验sha1编码
                console.log('entry.toURL():', entry.toURL());

                cordova.sino.sha1(entry.toURL(), function (result) {
                    if (result && result.flag == 1) {
                        if (result.sha1 === datas[index].sha1) {
                            unzip(entry.toURL(), datas, index, callback);
                        } else {
                            // 签名校验失败  返回错误信息 更新包类型名称 + 更新包版本 + 错误原因
                            callback({ flag: 0, cause: datas[index].typeName + ' ' + datas[index].toVersion + '签名校验失败' });
                        }
                    } else {
                        callback({ flag: 0, cause: datas[index].typeName + ' ' + datas[index].toVersion + '计算校验出错;' + result });
                    }
                })
            }

            function onDownloadError(error) {
                log('下载' + datas[index].typeName + ' ' + datas[index].toVersion + '更新包失败');
                console.log(error);
                callback({ flag: 0 });
            }

            fileTransfer.onprogress = function (progressEvent) {
                log('更新中 ' + Math.floor((progressEvent.loaded / progressEvent.total) * 100) + "%");
                // log('下载'+datas[index].typeName+'更新包:' + Math.floor((progressEvent.loaded / progressEvent.total) * 100) + "%");
            };

            //下载更新包
            fileTransfer.download(url, cordova.file.dataDirectory + 'update.zip', onDownloadSuccess, onDownloadError, true);
        }

        /**
         * 解压数组中的多个包
         * @param {*} datas
         * @param {*} callback
         * @param {*} index
         */
        function unzips(datas, callback, index) {
            index = index || 0;
            unzip(datas[index].filePath, [datas[index]], 0, function (result) {
                // 解压失败直接回调
                if (result.flag == 0) {
                    callback({ flag: 0 })
                } else {
                    // 如果是最后一个 则调用回调
                    if (index === datas.length - 1) {
                        callback({ flag: 1 });
                    } else {// 不是最后一个继续调用
                        unzips(datas, callback, index + 1);
                    }
                }
            })
        }

        function unzip(filePath, datas, index, callback) {
            var UNZIPPATH = HTMLPATH;
            // 如果是magnum 更新包 修改解压目录 并删除原来的文件
            if (datas[index].type == 'MAGNUM') {
                UNZIPPATH = MAGNUMPATH;
                sino_file.delete(UNZIPPATH, next, next);
            } else if (datas[index].type === 'WEB' && datas[index].packageType === 'FULL') { // 对于前端页面包 只有全量包需要 删除原来的文件 
                sino_file.delete(UNZIPPATH, next, next);
            } else if (datas[index].type === 'WEB' && datas[index].packageType === 'PATCH') { // 对于增量包 需要删除patch。json
                sino_file.delete(UNZIPPATH + 'www/patch.json', next, next);
            } else {
                next();
            }

            function next() {
                console.log('UNZIPPATH:', UNZIPPATH)
                zip.unzip(filePath, UNZIPPATH, function (data) {
                    if (data == 0) {
                        //解压完成后更新本地保存的版本号
                        if (datas[index].type == 'WEB') {
                            localStorage.WebAppVersion = datas[index].toVersion;
                        } else {
                            localStorage[LATEST_BASE_RULE_VERSION] = datas[index].toVersion;
                        }

                        log('解压' + datas[index].typeName + ' ' + datas[index].toVersion + '成功');
                        // 如果是增量包 需要删除一些文件 
                        if (datas[index].packageType === 'PATCH') {
                            deleteFilesWithFileList(cordova.file.dataDirectory + 'www/patch.json?v=' + (new Date().getTime()), cleanBack)
                        } else {
                            cleanBack()
                        }
                    } else {
                        // log('解压更新包失败');
                        callback({ flag: 0 });
                    }
                }, function (progressEvent) {
                    log('解压更新包:' + Math.floor((progressEvent.loaded / progressEvent.total) * 100) + "%");
                });
            }

            function cleanBack() {
                //如果是最后一个调用回调函数 否则继续下载更新
                if (index == datas.length - 1) {
                    callback({ flag: 1 });
                } else {
                    downAndUnZip(datas, callback, index + 1);
                }
            }
        }

        /**
         * 根据patch.json文件删除文件
         * @param {*} patchJsonPath 
         * @param {*} callback 
         */
        function deleteFilesWithFileList(patchJsonPath, callback) {
            $.ajax({
                url: patchJsonPath,
                success: function (result) {
                    try {
                        result = JSON.parse(result);
                        console.log('文件列表', result);
                        var deletes = result.deleteList;
                        for (var i = 0; i < deletes.length; i++) {
                            deletes[i] = cordova.file.dataDirectory + 'www' + deletes[i];
                        }
        
                        if(deletes.length > 0)deleteWebfiles(deletes, callback);
                        else callback({ flag: 1 });
                    } catch (e) {
                        console.warn(e);
                        callback({ flag: 1 });
                    }
                    
                }
            })
        }

        function deleteWebfiles(files, callback, index) {
            index = index || 0;
            sino_file.delete(files[index], next, next);

            // 删除后调用方法
            function next() {
                // 如果是最后一个 则回调
                if (index >= files.length - 1) {
                    callback({ flag: 1 })
                } else {
                    deleteWebfiles(files, callback, index + 1);
                }

            }
        }

        function log(msg) {
            console.log(msg);
            // $('#result').html('当前版本为' + localStorage.WebAppVersion + '<br />' + msg);
            $('#result').css('background-color', 'white');
            $('#result').html(msg);

        }

        function getParams(url) {
            var data = {};
            var str = url || location.href;
            var index = str.indexOf('?');
            // 如果?为最后一个字符 则表示没有参数
            if (index + 1 === str.length) return data;
            // 截取? 后面部分
            if (index !== -1) str = str.slice(index + 1);
            // 去掉# 后面部分
            index = str.indexOf('#');
            if (index !== -1) str = str.slice(0, index);

            var dataArr = str.split('&');
            for (var i = 0; i < dataArr.length; i++) {
                var _dataArr = dataArr[i].split('=');
                data[_dataArr[0]] = _dataArr[1];
            }
            return data;
        };

        function version2Num(str) {
            if (!str) return 0;
            var arr = str.split('.');
            var result = '';
            for (var i = 0; i < arr.length; i++) {
                var num = arr[i]
                num = padStr(num, 2, '0');
                result += num;
            }
            return parseInt(result, 10);
        };

        function num2Version(num) {
            if (!num || (num + '').indexOf('.') !== -1) return num;
            var numStr = padStr((num + ''), 6, '0');
            var bigVersion = parseInt(numStr.slice(0, 2), 10) + '';
            var midVersion = parseInt(numStr.slice(2, 4), 10) + '';
            var litVersion = parseInt(numStr.slice(4), 10) + '';
            return bigVersion + '.' + midVersion + '.' + litVersion;
        }

        function padStr (str, length, pad) {
            str = str || '';
            
            while(str.length < length) {
                str = pad + str;
            }
            
            return str;
        }
    });
});