/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        this.receivedEvent('deviceready');
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
        var listeningElement = parentElement.querySelector('.listening');
        var receivedElement = parentElement.querySelector('.received');

        listeningElement.setAttribute('style', 'display:none;');
        receivedElement.setAttribute('style', 'display:block;');

        console.log('Received Event: ' + id);

        var _device = document.querySelector('#device');
        var _camera = document.querySelector('#camera');
        var _call = document.querySelector('#phonecall');
        var _appversion = document.querySelector('#appversion');
        var _imagepicker = document.querySelector('#imagepicker');
        var _w_div = document.querySelector('#w_div');
        _device.onclick = function () {
            if (device) {
                alert('device:' + device.uuid);
            } else if (Device) {
                alert('Device:' + Device.uuid);
            }
        },
        _camera.onclick = function(){
            var srcType = Camera.PictureSourceType.CAMERA;
            var selection = "camera-thmb";
             var options = {
                        // Some common settings are 20, 50, and 100
                        // quality: 80,
                        destinationType: Camera.DestinationType.DATA_URL,
                        // In this app, dynamically set the picture source, Camera or photo gallery
                        sourceType: srcType,
                        encodingType: Camera.EncodingType.JPEG,
                        mediaType: Camera.MediaType.PICTURE,
                        allowEdit: false,
//                        scaleWidth: 1000,
                        targetHeight:100,
                        targetWidth: 100
//                        isGuideFrameShow: true,
//                        Household,IDCard-front,IDCard-back
//                        guideFrameType: "Household"
                       // correctOrientation: true  //Corrects Android orientation quirks
                    }

//            navigator.camera.ocrTakePicture(function cameraSuccess(imageUri) {
            navigator.camera.getPicture(function cameraSuccess(imageData) {
                // Do something
                console.debug("success---" + imageData);
                var imgss = document.createElement('img')
                imgss.style.width = 300 + "px"
                imgss.src = "data:image/jpeg;base64," + imageData
                _w_div.appendChild(imgss)

            }, function cameraError(error) {
                console.debug("Unable to obtain picture: " + error, "app");

            }, options);
        },
        _call.onclick = function(){
            cordova.plugins.SinoLivess.startLivess(function(succ) {console.log(succ)},function(error) {console.log(error)});
//            cordova.plugins.phonedialer.dial(
//              "15510134769",
//              function(err) {
//                if (err == "empty") alert("Unknown phone number");
//                else alert("Dialer Error:" + err);
//              },
//              function(success) { alert('Dialing succeeded'); }
//             );
        },
        _imagepicker.onclick = function(){
            window.imagePicker.getPictures(
                function(results) {
                    for (var i = 0; i < results.length; i++) {
                        console.log('Image URI: ' + results[i]);
                    }
                }, function (error) {
                    console.log('Error: ' + error);
                }, {
                    maximumImagesCount: 10,
                    //返回base64
                    outputType: 1,
                    scaleWidth: 1000
                }
            );
        },
        _appversion.onclick = function(){
            cordova.plugins.getVersion(
              "",
              function(success) { alert(success.appVersion); },
              function(err) {
                alert("Dialer Error:" + err);
              }
            );
        }
    },
    setOptions: function(srcType) {
        var options = {
            // Some common settings are 20, 50, and 100
            quality: 50,
            destinationType: Camera.DestinationType.FILE_URI,
            // In this app, dynamically set the picture source, Camera or photo gallery
            sourceType: srcType,
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            allowEdit: true,
            correctOrientation: true  //Corrects Android orientation quirks
        }
        return options;
    },

//    function openCamera(selection) {
//
//        var srcType = Camera.PictureSourceType.CAMERA;
//        var options = setOptions(srcType);
//        var func = createNewFileEntry;
//
//        navigator.camera.getPicture(function cameraSuccess(imageUri) {
//
//            displayImage(imageUri);
//            // You may choose to copy the picture, save it somewhere, or upload.
//            func(imageUri);
//
//        }, function cameraError(error) {
//            console.debug("Unable to obtain picture: " + error, "app");
//
//        }, options);
//    }

    openCamera: function(selection) {

        var srcType = Camera.PictureSourceType.CAMERA;
        var options = setOptions(srcType);
        var func = createNewFileEntry;

        if (selection == "camera-thmb") {
            options.targetHeight = 100;
            options.targetWidth = 100;
        }

        navigator.camera.getPicture(function cameraSuccess(imageUri) {

            // Do something

        }, function cameraError(error) {
            console.debug("Unable to obtain picture: " + error, "app");

        }, options);
    }
};

app.initialize();
