cordova.define("cordova-plugin-BDLocation.BDLocation", function(require, exports, module) {
var exec = require('cordova/exec');
var BDLocation = {};

BDLocation.Type = BDLocation.COORTYPE = {
  //百度经纬度坐标
  BD09LL: 0,
  //国测局坐标
  GCJ02: 3
}

/**
* 获取定位
* @param arg0: JSON, {
  coorType: 坐标系： BDLocation.Type.BD09LL 百度坐标系 BDLocation.Type.GCJ02 国测局坐标
}
*/
BDLocation.currentLocation = function (arg0, success, error) {
  exec(success, error, 'BaiduLocation', 'currentLocation', [arg0]);
}

/**
   * 定位
   * @param {*} success 成功回调
   * @param {*} error  失败回调
   * @param {*} coorType 默认COORTYPE.GCJ02 国测局坐标 COORTYPE.BD09LL 百度坐标系 
   */
 BDLocation.location = function (success, error, coorType) {
  if (coorType !== BDLocation.COORTYPE.GCJ02 || coorType !== BDLocation.COORTYPE.BD09LL) {
    coorType = BDLocation.COORTYPE.GCJ02;
  }
  
  exec(success, error, 'BaiduLocation', 'currentLocation', [{coorType: coorType}]);
}
/**
* 经纬度转定位街道信息
* @param arg0：JSON 经纬度信息 {
  latitude: 纬度
  longitude: 经度
}
*/
BDLocation.coordinateToAddress = function (arg0, success, error) {
  exec(success, error, 'BaiduLocation', 'coordinateToAddress', [arg0]);
}

/**
* 定位街道信息转经纬度
* @param arg0：JSON 地址信息 {
  addr: 地址
  city: 城市
}
*/
BDLocation.addressToCoordinates = function (arg0, success, error) {
  exec(success, error, 'BaiduLocation', 'addressToCoordinates', [arg0]);
}
module.exports = BDLocation;

});
